﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.OleDb;
using Infragistics.WebUI.UltraWebGrid;

public partial class HierarchicalUWG : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
       
        // if (Session.Count > 0)
        //{
        //    int rowIndex = (int)Session["rowIndex"];
        //    string bandKey = (string)Session["bandKey"];
        //    int parentRowIndex = (int)Session["parentRowIndex"];
        //    UltraWebGrid1.Rows[parentRowIndex].Expand(true);
        //    UltraWebGrid1.Rows[parentRowIndex].Rows[rowIndex].Selected = true;
        //}   
     
    }

    private DataSet CreateHierarcalData()
    {
        DataSet dsSource = new DataSet();

        DataTable dtCustomers = CreateData("Customers");
        DataTable dtOrders = CreateData("Orders");

        dsSource.Tables.Add(dtCustomers);
        dsSource.Tables.Add(dtOrders);

        // Create the relationgship between the Customers and Orders table
        dsSource.Relations.Add("MyRelation", dtCustomers.Columns["CustomerId"],
            dtOrders.Columns["CustomerId"]);

        dsSource.AcceptChanges();
        return dsSource;
    }

    private DataTable CreateData(string tableName)
    {
        DataTable dtData = new DataTable();

        // Do not forget to change the connection string  
        // to access your local database
        string connString = @"Provider=Microsoft.Jet.OLEDB.4.0;" +
        @"Data Source=|DataDirectory|\Nwind.mdb;" +
        @"Persist Security Info=True";


        OleDbConnection oleDbConn = new OleDbConnection(connString);

        // I put the [] brackets because "Order" is reserved word in SQL
        String cmdText = "SELECT * FROM [" + tableName + "]";
        // Select all columns from the table
        OleDbCommand oleDbComm = new OleDbCommand(cmdText, oleDbConn);

        // Create the adapter 
        OleDbDataAdapter oleDataAdapter = new OleDbDataAdapter(oleDbComm);

        // Fill the data table and return it

        oleDataAdapter.Fill(dtData);
        return dtData;
    }
    protected void UltraWebGrid1_InitializeRow(object sender, RowEventArgs e)
    {
        // checks if the row is in the child band 
        // and then sets the 
        if (e.Row.Band.Index == 0)
        {          
          //  e.Row.Expand(true);
        }
        if (e.Row.Band.Index == 1)
        {

            UltraGridCell cell1 = e.Row.Cells.FromKey("ShipAddress");
            cell1.TargetURL = "http://www.infragistics.com";
            UltraGridCell cell2 = e.Row.Cells.FromKey("ShipName");
            cell2.TargetURL = string.Format("@[_blank]http://www.google.bg/search?q={0}", cell2.Text);
         //   e.Row.Style.CssClass = "cellswhitechild";
         //  e.Row.Band.HeaderStyle.CssClass = "topcellscolordarkgrey";

            e.Row.Cells[0].Text ="<table width='100%' style='border-style: none;'>    <tr>     <td>  Total = 200.00  </td>   <td>        <img id='Img1' src='ig_res/Default/images/del_up.gif' runat='server' />  </td>   </tr>   </table>";

        }    
        
    }
    

    protected void UltraWebGrid1_AddRow(object sender, RowEventArgs e)
    {
        e.Row.Style.CssClass = "cellswhitechild";
    }
    protected void UltraWebGrid1_InitializeBand(object sender, BandEventArgs e)
    {
        if (e.Band.Index == 1)
        {
            //e.Band.ColHeadersVisible = ShowMarginInfo.No;
            //e.Band.Columns[0].Footer.Caption = "Total";
        }

        if (e.Band.Index == 0)
        {
           // e.Band.Indentation= 1;
        }
    }
    protected void UltraWebGrid1_FilterPopulating(object sender, FilterDropDownEventArgs e)
    {

    }
  
    protected void UltraWebGrid1_ClickCellButton(object sender, CellEventArgs e)
    {
        if (e.Cell.Row.HasParent)
        {
            int rowIndex = e.Cell.Row.Index;
            UltraGridRow parentRow = e.Cell.Row.ParentRow;
            UltraGridBand band = e.Cell.Row.ParentRow.Band;

            Session["rowIndex"] = rowIndex;
            Session["bandKey"] = band.Key;
            Session["parentRowIndex"] = parentRow.Index;
        }

        Response.Redirect("http://www.infragistics.com");

    }
    protected void UltraWebGrid1_Init(object sender, EventArgs e)
    {

    }

    protected void UltraWebGrid1_UpdateRow(object sender, RowEventArgs e)
    {
        //UltraGridRow oldRow = (UltraGridRow)e.Data;

        //string dataKey = (string)e.Row.DataKey.ToString().Trim();
        //DataSet ds1 = (DataSet)Session["data"];
        //if (null != dataKey)
        //{
        //    // First we locate the row in the DataTable object with the corresponding key.
        //    // If primary key field is editable, must use old row's key to find the row.
        //    DataRow dr = ds1.Tables[0].Rows.Find(new object[] { dataKey });

        //    try
        //    {
        //        if (null != dr)
        //            // The update code is similar to that used inside of the Add case.
        //            foreach (UltraGridCell c in e.Row.Cells)
        //                // this check is because we have unbound columns
        //                // in the grid which have no datasource representation
        //                if (-1 != ds1.Tables[0].Columns.IndexOf(c.Column.Key))
        //                    if (!dr[c.Column.Key].Equals(c.Value))
        //                        dr[c.Column.Key] = c.Value;
        //    }
        //    catch (Exception ex)
        //    {
        //        Label1.Text = ex.Message;

        //        this.UltraWebGrid1.DataSource = ds1.Tables[1];
        //        this.UltraWebGrid1.DataBind();
        //    }

        //    // Normally you would not allow modification of the value
        //    // that is used to populate your DataKey as this most
        //    // often corresponds to your primary key.  However, should you allow 
        //    // for the field that is used for the DataKey, you should
        //    // update this value.
        //    e.Row.DataKey = e.Row.Cells.FromKey("CustomerID").Value;
        //}

    }
    protected void UltraWebGrid1_InitializeDataSource1(object sender, UltraGridEventArgs e)
    {
        int count = UltraWebGrid1.DisplayLayout.SelectedRows.Count;
        if ( Session ["data"] != null)
        {
            this.UltraWebGrid1.DataSource = Session ["data"];
        }
        else{
            this.UltraWebGrid1.DataSource = CreateHierarcalData();
            Session["data"] = CreateHierarcalData();
        }
        
    }
    protected void UltraWebGrid1_InitializeLayout(object sender, LayoutEventArgs e)
    {
      //  e.Layout.Bands[0].Expandable = Expandable.Yes;
    }
    protected void UltraWebGrid1_ExpandRow(object sender, RowEventArgs e)
    {          
       //e.Row.Rows[0].Cells[0].Text = 
       //    "<table width='100%' style='border-style: none;'> " +
       //       " <tr>     <td>  Total = 200.00  </td>   <td>   " +
       //          "<img id='Img1' src='ig_res/Default/images/add_up.gif' runat='server' /> " +
       //        " </td>   </tr>   </table>";
    }
    protected void UltraWebGrid1_PreRender(object sender, EventArgs e)
    {
       
    }
    protected void UltraWebGrid1_XmlHTTPRequest(object sender, XmlHTTPRequestEventArgs e)
    {
        if (e.Type == XmlHTTPRequestType.LoadMoreRows)
        {
            int currentRowNumber = e.RowNo;
            int rowsRange = UltraWebGrid1.DisplayLayout.RowsRange;

            e.Band.Expandable = Expandable.Yes;
            UltraGridBand band = e.Column.Band;
             
            if (band.Index ==0)
          
            for (int i = currentRowNumber -1 ; i < currentRowNumber + rowsRange ; i++)
            {
                band.Grid.Rows[i].Expand(true);
            }
        }
    }
    protected void UltraWebGrid1_DataBound(object sender, EventArgs e)
    {

    }
    protected void UltraWebGrid1_SelectedRowsChange(object sender, SelectedRowsEventArgs e)
    {

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        int count = UltraWebGrid1.DisplayLayout.SelectedRows.Count;
    }
}